<script setup lang="ts">
import { useBranchStore } from '@/views/Branch/stores/branch'
import { useEmployeeStore } from '../stores/employee'
import { computed } from 'vue'
import { ref } from 'vue'

const employeeStore = useEmployeeStore()
const branchStore = useBranchStore()
</script>

<template>
  <!-- <v-dialog v-model="employeeStore.dialog" persistent width="1024">
    <v-card rounded="xl">
      <v-card-title>
        <span class="text-h5">Employee Profile</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refForm" v-model="employeeStore.form" @submit.prevent="employeeStore.onSubmit">
          <v-container>
            <v-row>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="employeeStore.employeeItem.firstName"
                  :readonly="employeeStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  class="mb-2"
                  clearable
                  label="First Name"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="employeeStore.employeeItem.lastName"
                  :readonly="employeeStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Last Name"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="employeeStore.employeeItem.tel"
                  :readonly="employeeStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Tel."
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="4">
                <v-combobox
                  label="Gender"
                  :items="['Male', 'Female', 'Others']"
                  v-model="employeeStore.employeeItem.gender"
                ></v-combobox>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="employeeStore.employeeItem.birthDay"
                  :readonly="employeeStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Birth Date"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="employeeStore.employeeItem.title"
                  :readonly="employeeStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Title"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="employeeStore.employeeItem.qualification"
                  :readonly="employeeStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Qualification"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="employeeStore.employeeItem.moneyRate"
                  :readonly="employeeStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Money Rate"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="employeeStore.employeeItem.minWork"
                  :readonly="employeeStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Min Work"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
              </v-col>
            </v-row>
          </v-container>
        </v-form>
        <small>*indicates required field</small>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="employeeStore.closeDialog()">
          Close
        </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="employeeStore.save()"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog> -->
  <v-dialog v-model:model-value="employeeStore.dialog" style="width: 1000px" persistent>
    <v-card prepend-icon="mdi-account-box-multiple-outline" class="pa-5" title="Add Employee">
      <v-card-text>
        <v-container>
          <v-row>
            <v-col cols="12" sm="12" md="4">
              <v-img
                :src="'http://localhost:3000/images/employees/' + employeeStore.employeeItem.image"
                width="200"
              ></v-img>
            </v-col>

            <v-col cols="12" sm="12" md="4" class="pr-4">
              <v-file-input
                v-model="employeeStore.employeeItem.files"
                :rules="[
                  (value) => {
                    return (
                      !value ||
                      !value.length ||
                      value[0].size < 2000000 ||
                      'Image size should be less than 2 MB!'
                    )
                  }
                ]"
                accept="image/png, image/jpeg, image/bmp"
                placeholder="Pick an image"
                prepend-icon="mdi-image"
                label="Image"
              ></v-file-input>
            </v-col>
            <v-col cols="12" sm="12" md="4">
              <!-- <v-text-field
                v-model="employeeStore.employeeItem.branchID"
                :rules="[(v) => !!v || 'Field is required']"
                class="mb-2"
                clearable
                label="Branch ID"
              ></v-text-field> -->
              <v-combobox label="Branch ID" ></v-combobox>
            </v-col>
            <v-col cols="12" sm="12" md="4">
              <v-text-field
                v-model="employeeStore.employeeItem.firstName"
                :rules="[(v) => !!v || 'Field is required']"
                class="mb-2"
                clearable
                label="First Name"
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="12" md="4">
              <v-text-field
                v-model="employeeStore.employeeItem.lastName"
                :rules="[(v) => !!v || 'Field is required']"
                clearable
                label="Last Name"
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="12" md="4">
              <v-text-field
                v-model="employeeStore.employeeItem.tel"
                :rules="[(v) => !!v || 'Field is required']"
                clearable
                label="Tel."
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="4">
              <v-combobox
                label="Gender"
                :items="['Male', 'Female', 'Others']"
                v-model="employeeStore.employeeItem.gender"
              ></v-combobox>
            </v-col>
            <v-col cols="12" sm="12" md="4">
              <v-text-field
                v-model="employeeStore.employeeItem.title"
                :rules="[(v) => !!v || 'Field is required']"
                label="Title"
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="12" md="4">
              <v-text-field
                v-model="employeeStore.employeeItem.qualification"
                :rules="[(v) => !!v || 'Field is required']"
                clearable
                label="Qualification"
              ></v-text-field>
            </v-col>

            <v-col cols="12" sm="12" md="4">
              <v-text-field
                v-model="employeeStore.employeeItem.moneyRate"
                :rules="[(v) => !!v || 'Field is required']"
                clearable
                label="Money Rate"
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="12" md="4">
              <v-text-field
                v-model="employeeStore.employeeItem.minWork"
                :rules="[(v) => !!v || 'Field is required']"
                clearable
                label="Min Work"
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="12" md="4"> </v-col>
            <v-col cols="12" sm="12" md="4">
              <v-date-picker
                title="Birth Day"
                color="brown"
                v-model="employeeStore.employeeItem.birthDay"
                :rules="[(v: any) => !!v || 'Field is required']"
              ></v-date-picker>
            </v-col>
          </v-row>
        </v-container>
      </v-card-text>

      <template #actions>
        <v-row justify="end">
          <v-btn color="red" variant="outlined" @click="employeeStore.closeDialog()"> Cancel </v-btn>
          <v-btn color="blue" variant="elevated" @click="employeeStore.save()"> Save </v-btn>
        </v-row>
      </template>
    </v-card>
  </v-dialog>
</template>
